--- old/usr/src/uts/i86pc/os/cpuid.c	2014-04-23 20:47:21.169520913 -0400
+++ new/usr/src/uts/i86pc/os/cpuid.c	2014-04-23 20:47:21.175531636 -0400
@@ -22,6 +22,7 @@
  * Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright (c) 2011 by Delphix. All rights reserved.
  * Copyright 2013 Nexenta Systems, Inc. All rights reserved.
+ * Copyright 2014 Josef "Jeff" Sipek <jeffpc@josefsipek.net>
  */
 /*
  * Copyright (c) 2010, Intel Corporation.
@@ -163,7 +164,8 @@
 	"svm",
 	"topoext",
 	"f16c",
-	"rdrand"
+	"rdrand",
+	"x2apic",
 };
 
 boolean_t
@@ -1311,6 +1313,9 @@
 			}
 		}
 	}
+	if (cp->cp_ecx & CPUID_INTC_ECX_X2APIC) {
+		add_x86_feature(featureset, X86FSET_X2APIC);
+	}
 	if (cp->cp_edx & CPUID_INTC_EDX_DE) {
 		add_x86_feature(featureset, X86FSET_DE);
 	}
